LibreOJ 137. 最小瓶颈路(加强版) 题解 Kruscal重构树 ST表

声明:本题目是LibreOJ 136. 最小瓶颈路 题解 最小生成树 倍增加强版,建议先学习简单版的做法。

题目链接:LibreOJ 137. 最小瓶颈路(加强版)

题目描述:

给定一张无向图,询问两个结点之间的最小瓶颈路。u和v两个结点之间最小瓶颈路指的是u和v的每条路径中经过的最大边权的最小值。强制在线,期望实现询问时间复杂度为O(1)的算法。

题解:

给出结论:无向图的最小瓶颈路与其最小生成树上两个结点之间最小瓶颈路值相等。

上面结论的证明我们可以参考Krusca求解最小生成树的过程,对于当前可以加入的一条边(u, v, w),u和v之间的最小瓶颈路当前这条边,因为在之前的过程中经过权重比w小的边不能使u和v连通,根据这个过程我们便可以发现第一次让u和v相连的边的权重就是最小瓶颈路(这也是为什么Kruscal重构树可以求最小瓶颈路的原理),而不难发现这个值也就是u和v路径上的边权最大值。

有了上面的说明,我们可以构造Kruscal重构树,具体地:

使用Kruscal算法构造MST的时候,每选择一条边的时候,我们创建一个新的结点w,将u的根节点与w之间连接双向边,将v的根节点与w连接双向边,w的点权为当前选择的边的边权。这样构造出来的树叫做Kruscal重构树,不难发现,在该树中两个结点的LCA的点权为其最小瓶颈路(上面已经说明第一次合并的时候的边权即为最小瓶颈路,而LCA的点权就是第一次合并时选择边的边权)。我们不难发现深度越低的点的点权越大。

我们不难发现若初始有n个结点,那么Kruscal重构树一共有2n-1个结点,因此现在的问题变成了:需要快速查询两个结点的LCA的点权。如果题目不要求在线,那么我们可以通过Tarjan在O(n+m)的复杂度求出所有询问的LCA。

如果要求在线,我们可以借助Eular序和ST表实现,我们在DFS的过程中,在进入DFS的时候与访问完某个儿子结点的时候对当前结点进行标号,同时记录每个结点的第一次编号为in[u]。通过这样操作后,对于询问u和询问v,那么对于编号in[u]~in[v](或者in[v]~in[u])中的所有编号均为LCA(u,v)所在子树的结点的编号(这一点很容易思考,读者可以自己思考)。

由于深度越大的点的点权越大,所以有了Eular序之后,问题就变成了询问in[u]~in[v](或者in[v]~in[u])上的点权最小值,由于编号是连续的,我们可以使用ST表进行O(1)复杂度的查询。

代码:LibreOJ137

相关推荐
weixin_307779132 小时前
C++代码实现MATLAB中的dlarray函数功能
开发语言·c++·算法·matlab
Frank_refuel5 小时前
C++11之一场名为“搬家”的 C++ 之旅
开发语言·c++
hetao17338377 小时前
2026-10-03~04 hetao1733837 的刷题记录
c++·算法
Zootopia6268 小时前
飞行力学知识梳理1|飞行性能与稳定性
人工智能·python·算法·机器学习·无人机·学习方法·信息与通信
longlongzihan8 小时前
从LeetCode 70. 爬楼梯看动态规划:如何精准推导状态转移方程?
c++·算法·leetcode·动态规划
2601_960356389 小时前
2027校招采购岗解析:数学基础如何迁移到需求预测、成本与供应商分析
人工智能·算法
h_a_o777oah10 小时前
【树论】树链剖分:将树形结构转化为线性结构以处理树上路径问题(洛谷 P3384 附C++代码模板)
数据结构·算法·线段树·acm·树链剖分·树论·重链剖分
HEJOO910 小时前
指针的算术运算详解
java·数据结构·算法
Coder-magician10 小时前
《代码随想录》刷题打卡day47:并查集-part01
数据结构·算法·图论
lsc_blog10 小时前
远程和居家办公的经历,技术简历上怎么摆
面试·职场和发展·重构·pdf·求职招聘